services:
  - docker:dind

stages:
  - test
  - build
  - package
  - release

variables:
  CARGO_HOME: $CI_PROJECT_DIR/cargo_home

cache:
  paths:
    - cargo_home/
    - server/target/
    - webapp/node_modules/


test:server:
  stage: test
  image: 'rust:1.35'
  tags:
    - docker
  script:
    - apt update && apt install -y gcc make git
    - rustup default nightly-2019-05-10
    - make -C server test

test:webapp:
  stage: test
  image: 'node:lts'
  tags:
    - docker
  script:
    - make -C webapp install
    - make -C webapp test


build:server:
  stage: build
  image: 'rust:1.35'
  tags:
    - docker
  script:
    - apt update && apt install -y gcc make git
    - rustup default nightly-2019-05-10
    - make -C server build
  artifacts:
    paths:
    - server/dist

build:webapp:
  stage: build
  image: 'node:lts'
  tags:
    - docker
  script:
    - make -C webapp install
    - make -C webapp build
    # - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    # - make docker
    # - make docker_push
  artifacts:
    paths:
    - webapp/dist



package:docker:
  stage: package
  dependencies:
    - build:server
    - build:webapp
  image: docker:stable
  tags:
    - docker
  cache: {}
  script:
    - apk update && apk add make
    - make build_from_artifacts
    - make docker_build



release:docker:
  only:
    - tags
  stage: release
  dependencies:
    - build:server
    - build:webapp
  image: docker:stable
  tags:
    - docker
  cache: {}
  script:
    - apk update && apk add make
    - make build_from_artifacts
    - make docker_build
    - make docker_login
    - make docker_release
